USE [COWS]
GO
_CreateObject 'SP','dbo','GetUserInfo'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =========================================================
-- Author:		Jagannath Gangi
-- Create date: 2011-4-14
-- Description:	This SP is get User Info
-- =========================================================

ALTER PROCEDURE [dbo].[GetUserInfo]
@UserName VARCHAR(10) = NULL,
@UserID SMALLINT = NULL,
@UserStatus INT = NULL,
@GRPID SMALLINT = -1
AS
BEGIN
	SET NOCOUNT ON;

	BEGIN TRY

	IF (LEN(@UserName) > 0)
	BEGIN
		SELECT TOP 1 [USER_ID], USER_ADID, USER_ACF2_ID, FULL_NME, PHN_NBR, CELL_PHN_NBR, PGR_NBR, PGR_PIN_NBR, EMAIL_ADR, DSPL_NME, [ADMIN], ACTIVATOR, REVIEWER, MEMBER, REC_STUS_ID, MODFD_BY_USER_ID, MODFD_DT, MOD_FULL_NME
		FROM (SELECT UG.[USER_ID], LU.USER_ADID, LU.USER_ACF2_ID, LU.FULL_NME, LU.PHN_NBR, LU.CELL_PHN_NBR, LU.PGR_NBR, LU.PGR_PIN_NBR, LU.EMAIL_ADR, LU.DSPL_NME, LG.GRP_NME, LU.REC_STUS_ID, UG.REC_STUS_ID AS STUSID, LU.MODFD_BY_USER_ID, LU.MODFD_DT, LU2.FULL_NME as MOD_FULL_NME
		FROM dbo.LK_USER LU WITH (NOLOCK) INNER JOIN
		dbo.USER_GRP_ROLE UG WITH (NOLOCK) ON LU.[USER_ID] = UG.[USER_ID] INNER JOIN
		dbo.LK_GRP LG WITH (NOLOCK) ON LG.GRP_ID = UG.GRP_ID LEFT JOIN
		dbo.LK_USER LU2 WITH (NOLOCK) ON LU2.[USER_ID] = LU.MODFD_BY_USER_ID
		WHERE LU.USER_ADID = @UserName
		 AND LU.[USER_ID] <> 1
		 AND UG.GRP_ID = CASE COALESCE(@GRPID, -1) WHEN -1 THEN UG.GRP_ID ELSE @GRPID END
		 AND UG.REC_STUS_ID = CASE COALESCE(@GRPID, -1) WHEN -1 THEN UG.REC_STUS_ID ELSE 1 END
		 AND LU.REC_STUS_ID = CASE COALESCE(@UserStatus, -1) WHEN 1 THEN 1
															 WHEN 0 THEN 0
															 WHEN -1 THEN LU.REC_STUS_ID
															 ELSE LU.REC_STUS_ID END ) U
		PIVOT (SUM(STUSID) FOR GRP_NME IN ([ADMIN], ACTIVATOR, REVIEWER, MEMBER)) AS PVT
		ORDER BY [FULL_NME]
	END
	ELSE IF (COALESCE(@UserID, -1) <> -1)
	BEGIN
		SELECT TOP 1 [USER_ID], USER_ADID, USER_ACF2_ID, FULL_NME, PHN_NBR, CELL_PHN_NBR, PGR_NBR, PGR_PIN_NBR, EMAIL_ADR, DSPL_NME, [ADMIN], ACTIVATOR, REVIEWER, MEMBER, REC_STUS_ID, MODFD_BY_USER_ID, MODFD_DT, MOD_FULL_NME
		FROM (SELECT UG.[USER_ID], LU.USER_ADID, LU.USER_ACF2_ID, LU.FULL_NME, LU.PHN_NBR, LU.CELL_PHN_NBR, LU.PGR_NBR, LU.PGR_PIN_NBR, LU.EMAIL_ADR, LU.DSPL_NME, LG.GRP_NME, LU.REC_STUS_ID, UG.REC_STUS_ID AS STUSID, LU.MODFD_BY_USER_ID, LU.MODFD_DT, LU2.FULL_NME as MOD_FULL_NME
		FROM dbo.LK_USER LU WITH (NOLOCK) INNER JOIN
		dbo.USER_GRP_ROLE UG WITH (NOLOCK) ON LU.[USER_ID] = UG.[USER_ID] INNER JOIN
		dbo.LK_GRP LG WITH (NOLOCK) ON LG.GRP_ID = UG.GRP_ID LEFT JOIN
		dbo.LK_USER LU2 WITH (NOLOCK) ON LU2.[USER_ID] = LU.MODFD_BY_USER_ID
		WHERE LU.[USER_ID] = @UserID
		 AND LU.[USER_ID] <> 1
		 AND UG.GRP_ID = CASE COALESCE(@GRPID, -1) WHEN -1 THEN UG.GRP_ID ELSE @GRPID END
		 AND UG.REC_STUS_ID = CASE COALESCE(@GRPID, -1) WHEN -1 THEN UG.REC_STUS_ID ELSE 1 END
		 AND LU.REC_STUS_ID = CASE COALESCE(@UserStatus, -1) WHEN 1 THEN 1
															 WHEN 0 THEN 0
															 WHEN -1 THEN LU.REC_STUS_ID
															 ELSE LU.REC_STUS_ID END ) U
		PIVOT (SUM(STUSID) FOR GRP_NME IN ([ADMIN], ACTIVATOR, REVIEWER, MEMBER)) AS PVT
		ORDER BY [FULL_NME]
	END
	ELSE
	BEGIN
		SELECT [USER_ID], USER_ADID, USER_ACF2_ID, FULL_NME, PHN_NBR, CELL_PHN_NBR, PGR_NBR, PGR_PIN_NBR, EMAIL_ADR, DSPL_NME, [ADMIN], ACTIVATOR, REVIEWER, MEMBER, REC_STUS_ID, MODFD_BY_USER_ID, MODFD_DT, MOD_FULL_NME
		FROM (SELECT UG.[USER_ID], LU.USER_ADID, LU.USER_ACF2_ID, LU.FULL_NME, LU.PHN_NBR, LU.CELL_PHN_NBR, LU.PGR_NBR, LU.PGR_PIN_NBR, LU.EMAIL_ADR, LU.DSPL_NME, LG.GRP_NME, LU.REC_STUS_ID, UG.REC_STUS_ID AS STUSID, LU.MODFD_BY_USER_ID, LU.MODFD_DT, LU2.FULL_NME as MOD_FULL_NME
		FROM dbo.LK_USER LU WITH (NOLOCK) INNER JOIN
		dbo.USER_GRP_ROLE UG WITH (NOLOCK) ON LU.[USER_ID] = UG.[USER_ID] INNER JOIN
		dbo.LK_GRP LG WITH (NOLOCK) ON LG.GRP_ID = UG.GRP_ID LEFT JOIN
		dbo.LK_USER LU2 WITH (NOLOCK) ON LU2.[USER_ID] = LU.MODFD_BY_USER_ID
		WHERE LU.[USER_ID] <> 1 AND LU.REC_STUS_ID = CASE COALESCE(@UserStatus, -1) WHEN 1 THEN 1
															 WHEN 0 THEN 0
															 WHEN -1 THEN LU.REC_STUS_ID
															 ELSE LU.REC_STUS_ID END ) U
		PIVOT (SUM(STUSID) FOR GRP_NME IN ([ADMIN], ACTIVATOR, REVIEWER, MEMBER)) AS PVT
		ORDER BY [FULL_NME]
	END

END TRY
	BEGIN CATCH
		EXEC [dbo].[insertErrorInfo]
	END CATCH
END